Subject: Re: forwarding of ipv4 link local addresses

From: David Ahern <[email-masked]>
Date: Wed, 9 Dec 2015 12:04:17 -0700

On 12/9/15 6:44 AM, Thomas Graf wrote:
> On 12/03/15 at 02:35pm, David Miller wrote:
>> From: David Ahern <[email-masked]>
>> Date: Tue, 1 Dec 2015 13:35:58 -0800
>>
>>> RFC 3927 states that packets from/to IPv4 link-local addresses
>>> (169.254/16) should not be forwarded, yet the Linux networking stack
>>> happily forwards them. Before sending in a patch I wanted to inquire
>>> if this behavior is intentional.
>>
>> It probably won't break anything if we prohibit this, so sure send
>> a patch.
>
> I don't have the full email context so apologies if this is not
> relevant. The RFC states that such addresses should not be forwarded
> _beyond the local link_. So as long as you are not breaking forwarding
> of these addresses on the local host, I'm perfectly fine.

Hi Thomas:

The above is the full email context.

The behavior that one of our testers tripped over is packets sent to 
169.254 addresses received on link A are forwarded out link B. That's 
the behavior that was surprising and seems to violate the RFC.

>
> I bring this up specifically because of:
>
> commit d0daebc3d622f95db181601cb0c4a0781f74f758
> Author: Thomas Graf <[email-masked]>
> Date:   Tue Jun 12 00:44:01 2012 +0000
>
>      ipv4: Add interface option to enable routing of 127.0.0.0/8
>
>      Routing of 127/8 is tradtionally forbidden, we consider
>      packets from that address block martian when routing and do
>      not process corresponding ARP requests.
>
>      [...]
>
> This feature is being used by a popular PaaS which leverages the
> 127/8 address space locally without polluting an entire routeable
> address space.
>

Daniel pointed out this commit as well. I am referring strictly to 
169.254/16 addresses.